searchData={"items":[{"type":"module","title":"JSON.LD","doc":"An implementation of JSON-LD 1.0.\n\nAs an implementation of the `RDF.Serialization.Format` behaviour of RDF.ex\n\nsee","ref":"JSON.LD.html"},{"type":"function","title":"JSON.LD.compact/3","doc":"Compacts the given input according to the steps in the JSON-LD Compaction Algorithm.\n\n> Compaction is the process of applying a developer-supplied context to shorten\n> IRIs to terms or compact IRIs and JSON-LD values expressed in expanded form\n> to simple values such as strings or numbers. Often this makes it simpler to\n> work with document as the data is expressed in application-specific terms.\n> Compacted documents are also typically easier to read for humans.\n\n--  \n\nDetails at","ref":"JSON.LD.html#compact/3"},{"type":"function","title":"JSON.LD.context/2","doc":"Generator function for `JSON.LD.Context`s.\n\nYou can either pass a map with a `\"@context\"` key having the JSON-LD context\nobject its value, or the JSON-LD context object directly.\n\nThis function can be used also to create `JSON.LD.Context` from a `RDF.PropertyMap`.","ref":"JSON.LD.html#context/2"},{"type":"function","title":"JSON.LD.expand/2","doc":"Expands the given input according to the steps in the JSON-LD Expansion Algorithm.\n\n> Expansion is the process of taking a JSON-LD document and applying a `@context`\n> such that all IRIs, types, and values are expanded so that the `@context` is\n> no longer necessary.\n\n--  \n\nDetails at","ref":"JSON.LD.html#expand/2"},{"type":"function","title":"JSON.LD.flatten/3","doc":"Flattens the given input according to the steps in the JSON-LD Flattening Algorithm.\n\n> Flattening collects all properties of a node in a single JSON object and labels\n> all blank nodes with blank node identifiers. This ensures a shape of the data\n> and consequently may drastically simplify the code required to process JSON-LD\n> in certain applications.\n\n--  \n\nDetails at","ref":"JSON.LD.html#flatten/3"},{"type":"function","title":"JSON.LD.keyword?/1","doc":"Returns if the given value is a JSON-LD keyword.","ref":"JSON.LD.html#keyword?/1"},{"type":"function","title":"JSON.LD.keywords/0","doc":"The set of all JSON-LD keywords.\n\nsee","ref":"JSON.LD.html#keywords/0"},{"type":"function","title":"JSON.LD.node_map/2","doc":"Generator function for JSON-LD node maps.","ref":"JSON.LD.html#node_map/2"},{"type":"function","title":"JSON.LD.options/0","doc":"","ref":"JSON.LD.html#options/0"},{"type":"function","title":"JSON.LD.read_file/2","doc":"Deserializes a graph or dataset from a file.\n\nIt returns an `{:ok, data}` tuple, with `data` being the deserialized graph or\ndataset, or `{:error, reason}` if an error occurs.","ref":"JSON.LD.html#read_file/2"},{"type":"function","title":"Options - JSON.LD.read_file/2","doc":"General serialization-independent options:\n\n- `:stream`: Allows to enable reading the data from a file directly via a\nstream (default: `false` on this function, `true` on the bang version)\n- `:gzip`: Allows to read directly from a gzipped file (default: `false`)\n- `:file_mode`: A list with the Elixir `File.open` modes to be used for reading\n  (default: `[:read, :utf8]`)\n\nSee the [module documentation of the decoder](`Elixir.JSON.LD.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"JSON.LD.html#read_file/2-options"},{"type":"function","title":"JSON.LD.read_file!/2","doc":"Deserializes a graph or dataset from a file.\n\nAs opposed to `read_file/2`, it raises an exception if an error occurs and\ndefaults to `stream: true`.\n\nSee `read_file/3` for the available format-independent options.\n\nSee the [module documentation of the decoder](`Elixir.JSON.LD.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"JSON.LD.html#read_file!/2"},{"type":"function","title":"JSON.LD.read_stream/2","doc":"Deserializes a graph or dataset from a stream.\n\nIt returns an `{:ok, data}` tuple, with `data` being the deserialized graph or\ndataset, or `{:error, reason}` if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.JSON.LD.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"JSON.LD.html#read_stream/2"},{"type":"function","title":"JSON.LD.read_stream!/2","doc":"Deserializes a graph or dataset from a stream.\n\nAs opposed to `read_stream/2`, it raises an exception if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.JSON.LD.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"JSON.LD.html#read_stream!/2"},{"type":"function","title":"JSON.LD.read_string/2","doc":"Deserializes a graph or dataset from a string.\n\nIt returns an `{:ok, data}` tuple, with `data` being the deserialized graph or\ndataset, or `{:error, reason}` if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.JSON.LD.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"JSON.LD.html#read_string/2"},{"type":"function","title":"JSON.LD.read_string!/2","doc":"Deserializes a graph or dataset from a string.\n\nAs opposed to `read_string/2`, it raises an exception if an error occurs.\n\nSee the [module documentation of the decoder](`Elixir.JSON.LD.Decoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the decoder.","ref":"JSON.LD.html#read_string!/2"},{"type":"function","title":"JSON.LD.write_file/3","doc":"Serializes an RDF data structure to a file.\n\nIt returns `:ok` if successful or `{:error, reason}` if an error occurs.","ref":"JSON.LD.html#write_file/3"},{"type":"function","title":"Options - JSON.LD.write_file/3","doc":"General serialization-independent options:\n\n- `:stream`: Allows to enable writing the serialized data to the file directly\n  via a stream. Possible values: `:string` or `:iodata` for writing to the file\n  with a stream of strings respective IO lists, `true` if you want to use streams,\n  but don't care for the exact method or `false` for not writing with\n  a stream (default: `false` on this function, `:iodata` on the bang version)\n- `:gzip`: Allows to write directly to a gzipped file (default: `false`)\n- `:force`: If not set to `true`, an error is raised when the given file\n  already exists (default: `false`)\n- `:file_mode`: A list with the Elixir `File.open` modes to be used for writing\n  (default: `[:write, :exclusive]`)\n\nSee the [module documentation of the encoder](`Elixir.JSON.LD.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"JSON.LD.html#write_file/3-options"},{"type":"function","title":"JSON.LD.write_file!/3","doc":"Serializes an RDF data structure to a file.\n\nAs opposed to `write_file/3`, it raises an exception if an error occurs.\n\nSee `write_file/3` for the available format-independent options.\n\nSee the [module documentation of the encoder](`Elixir.JSON.LD.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"JSON.LD.html#write_file!/3"},{"type":"function","title":"JSON.LD.write_string/2","doc":"Serializes an RDF data structure to a string.\n\nIt returns an `{:ok, string}` tuple, with `string` being the serialized graph or\ndataset, or `{:error, reason}` if an error occurs.\n\nSee the [module documentation of the encoder](`Elixir.JSON.LD.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"JSON.LD.html#write_string/2"},{"type":"function","title":"JSON.LD.write_string!/2","doc":"Serializes an RDF data structure to a string.\n\nAs opposed to `write_string/2`, it raises an exception if an error occurs.\n\nSee the [module documentation of the encoder](`Elixir.JSON.LD.Encoder`) for the\navailable format-specific options, all of which can be used in this\nfunction and will be passed them through to the encoder.","ref":"JSON.LD.html#write_string!/2"},{"type":"module","title":"JSON.LD.Compaction","doc":"Implementation of the JSON-LD 1.0 Compaction Algorithms.","ref":"JSON.LD.Compaction.html"},{"type":"function","title":"JSON.LD.Compaction.compact/3","doc":"","ref":"JSON.LD.Compaction.html#compact/3"},{"type":"function","title":"JSON.LD.Compaction.compact_iri/6","doc":"IRI Compaction\n\nDetails at","ref":"JSON.LD.Compaction.html#compact_iri/6"},{"type":"function","title":"JSON.LD.Compaction.compact_value/4","doc":"Value Compaction\n\nDetails at","ref":"JSON.LD.Compaction.html#compact_value/4"},{"type":"function","title":"JSON.LD.Compaction.select_term/5","doc":"Term Selection\n\nDetails at","ref":"JSON.LD.Compaction.html#select_term/5"},{"type":"module","title":"JSON.LD.Context","doc":"Implementation of the JSON-LD 1.0 Context Processing Algorithms.","ref":"JSON.LD.Context.html"},{"type":"function","title":"JSON.LD.Context.base/1","doc":"","ref":"JSON.LD.Context.html#base/1"},{"type":"function","title":"JSON.LD.Context.create/2","doc":"","ref":"JSON.LD.Context.html#create/2"},{"type":"function","title":"JSON.LD.Context.create_term_definition/5","doc":"Expands the given input according to the steps in the JSON-LD Create Term Definition Algorithm.\n\nsee","ref":"JSON.LD.Context.html#create_term_definition/5"},{"type":"function","title":"JSON.LD.Context.empty?/1","doc":"","ref":"JSON.LD.Context.html#empty?/1"},{"type":"function","title":"JSON.LD.Context.inverse/1","doc":"Inverse Context Creation algorithm\n\nDetails at","ref":"JSON.LD.Context.html#inverse/1"},{"type":"function","title":"JSON.LD.Context.language/2","doc":"","ref":"JSON.LD.Context.html#language/2"},{"type":"function","title":"JSON.LD.Context.new/1","doc":"","ref":"JSON.LD.Context.html#new/1"},{"type":"function","title":"JSON.LD.Context.update/4","doc":"","ref":"JSON.LD.Context.html#update/4"},{"type":"type","title":"JSON.LD.Context.local/0","doc":"","ref":"JSON.LD.Context.html#t:local/0"},{"type":"type","title":"JSON.LD.Context.remote/0","doc":"","ref":"JSON.LD.Context.html#t:remote/0"},{"type":"type","title":"JSON.LD.Context.t/0","doc":"","ref":"JSON.LD.Context.html#t:t/0"},{"type":"type","title":"JSON.LD.Context.value/0","doc":"","ref":"JSON.LD.Context.html#t:value/0"},{"type":"module","title":"JSON.LD.Context.TermDefinition","doc":"Struct for the term definitions in a `JSON.LD.Context`.","ref":"JSON.LD.Context.TermDefinition.html"},{"type":"type","title":"JSON.LD.Context.TermDefinition.t/0","doc":"","ref":"JSON.LD.Context.TermDefinition.html#t:t/0"},{"type":"module","title":"JSON.LD.Decoder","doc":"A decoder for JSON-LD serializations to `RDF.Dataset`s.\n\nAs for all decoders of `RDF.Serialization.Format`s, you normally won't use these\nfunctions directly, but via one of the `read_` functions on the `JSON.LD` format\nmodule or the generic `RDF.Serialization` module.","ref":"JSON.LD.Decoder.html"},{"type":"function","title":"JSON.LD.Decoder.node_to_rdf/1","doc":"","ref":"JSON.LD.Decoder.html#node_to_rdf/1"},{"type":"function","title":"JSON.LD.Decoder.parse_json/2","doc":"","ref":"JSON.LD.Decoder.html#parse_json/2"},{"type":"function","title":"JSON.LD.Decoder.parse_json!/2","doc":"","ref":"JSON.LD.Decoder.html#parse_json!/2"},{"type":"function","title":"JSON.LD.Decoder.to_rdf/2","doc":"","ref":"JSON.LD.Decoder.html#to_rdf/2"},{"type":"behaviour","title":"JSON.LD.DocumentLoader","doc":"Behaviour for document loaders used to retrieve remote documents and contexts.\n\nas specified at","ref":"JSON.LD.DocumentLoader.html"},{"type":"callback","title":"JSON.LD.DocumentLoader.load/2","doc":"","ref":"JSON.LD.DocumentLoader.html#c:load/2"},{"type":"module","title":"JSON.LD.DocumentLoader.Default","doc":"Default implementation of the `JSON.LD.DocumentLoader` behaviour.","ref":"JSON.LD.DocumentLoader.Default.html"},{"type":"function","title":"JSON.LD.DocumentLoader.Default.load/2","doc":"","ref":"JSON.LD.DocumentLoader.Default.html#load/2"},{"type":"module","title":"JSON.LD.DocumentLoader.RemoteDocument","doc":"A struct for remote documents.","ref":"JSON.LD.DocumentLoader.RemoteDocument.html"},{"type":"type","title":"JSON.LD.DocumentLoader.RemoteDocument.t/0","doc":"","ref":"JSON.LD.DocumentLoader.RemoteDocument.html#t:t/0"},{"type":"module","title":"JSON.LD.Encoder","doc":"An encoder for JSON-LD serializations of RDF.ex data structures.\n\nAs for all encoders of `RDF.Serialization.Format`s, you normally won't use these\nfunctions directly, but via one of the `write_` functions on the `JSON.LD`\nformat module or the generic `RDF.Serialization` module.","ref":"JSON.LD.Encoder.html"},{"type":"module","title":"Options - JSON.LD.Encoder","doc":"- `:context`: When a context map or remote context URL string is given,\n  compaction is performed using this context\n- `:base`: : Allows to specify a base URI to be used during compaction\n  (only when `:context` is provided).\n  Default is the base IRI of the encoded graph or if none present or in case of\n  encoded datasets the `RDF.default_base_iri/0`.\n- `:use_native_types`: If this flag is set to `true`, RDF literals with a datatype IRI\n  that equals `xsd:integer` or `xsd:double` are converted to a JSON numbers and\n  RDF literals with a datatype IRI that equals `xsd:boolean` are converted to `true`\n  or `false` based on their lexical form. (default: `false`)\n- `:use_rdf_type`: Unless this flag is set to `true`, `rdf:type` predicates will be\n  serialized as `@type` as long as the associated object is either an IRI or blank\n  node identifier. (default: `false`)\n\nThe given options are also passed through to `Jason.encode/2`, so you can also\nprovide any the options this function supports, most notably the `:pretty` option.","ref":"JSON.LD.Encoder.html#module-options"},{"type":"function","title":"JSON.LD.Encoder.from_rdf/2","doc":"","ref":"JSON.LD.Encoder.html#from_rdf/2"},{"type":"function","title":"JSON.LD.Encoder.from_rdf!/2","doc":"","ref":"JSON.LD.Encoder.html#from_rdf!/2"},{"type":"type","title":"JSON.LD.Encoder.input/0","doc":"","ref":"JSON.LD.Encoder.html#t:input/0"},{"type":"module","title":"JSON.LD.Expansion","doc":"Implementation of the JSON-LD 1.0 Expansion Algorithms.","ref":"JSON.LD.Expansion.html"},{"type":"function","title":"JSON.LD.Expansion.expand/2","doc":"","ref":"JSON.LD.Expansion.html#expand/2"},{"type":"function","title":"JSON.LD.Expansion.expand_value/3","doc":"Details at","ref":"JSON.LD.Expansion.html#expand_value/3"},{"type":"module","title":"JSON.LD.Flattening","doc":"Implementation of the JSON-LD 1.0 Flattening Algorithms.","ref":"JSON.LD.Flattening.html"},{"type":"function","title":"JSON.LD.Flattening.flatten/3","doc":"","ref":"JSON.LD.Flattening.html#flatten/3"},{"type":"function","title":"JSON.LD.Flattening.generate_node_map/7","doc":"Node Map Generation\n\nDetails at","ref":"JSON.LD.Flattening.html#generate_node_map/7"},{"type":"function","title":"JSON.LD.Flattening.node_map/2","doc":"","ref":"JSON.LD.Flattening.html#node_map/2"},{"type":"module","title":"JSON.LD.IRIExpansion","doc":"Implementation of the JSON-LD 1.0 IRI Expansion algorithm.","ref":"JSON.LD.IRIExpansion.html"},{"type":"function","title":"JSON.LD.IRIExpansion.expand_iri/6","doc":"see http://json-ld.org/spec/latest/json-ld-api/#iri-expansion","ref":"JSON.LD.IRIExpansion.html#expand_iri/6"},{"type":"module","title":"JSON.LD.NodeIdentifierMap","doc":"","ref":"JSON.LD.NodeIdentifierMap.html"},{"type":"function","title":"JSON.LD.NodeIdentifierMap.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"JSON.LD.NodeIdentifierMap.html#child_spec/1"},{"type":"function","title":"JSON.LD.NodeIdentifierMap.generate_blank_node_id/2","doc":"Generate Blank Node Identifier\n\nDetails at","ref":"JSON.LD.NodeIdentifierMap.html#generate_blank_node_id/2"},{"type":"function","title":"JSON.LD.NodeIdentifierMap.init/1","doc":"","ref":"JSON.LD.NodeIdentifierMap.html#init/1"},{"type":"function","title":"JSON.LD.NodeIdentifierMap.start_link/1","doc":"","ref":"JSON.LD.NodeIdentifierMap.html#start_link/1"},{"type":"function","title":"JSON.LD.NodeIdentifierMap.stop/3","doc":"","ref":"JSON.LD.NodeIdentifierMap.html#stop/3"},{"type":"module","title":"JSON.LD.Options","doc":"Options accepted by the JSON-LD processing algorithms.\n\nas specified at","ref":"JSON.LD.Options.html"},{"type":"function","title":"JSON.LD.Options.new/0","doc":"","ref":"JSON.LD.Options.html#new/0"},{"type":"function","title":"JSON.LD.Options.new/1","doc":"","ref":"JSON.LD.Options.html#new/1"},{"type":"function","title":"JSON.LD.Options.set_base/2","doc":"","ref":"JSON.LD.Options.html#set_base/2"},{"type":"type","title":"JSON.LD.Options.convertible/0","doc":"","ref":"JSON.LD.Options.html#t:convertible/0"},{"type":"type","title":"JSON.LD.Options.t/0","doc":"","ref":"JSON.LD.Options.html#t:t/0"},{"type":"module","title":"JSON.LD.Utils","doc":"","ref":"JSON.LD.Utils.html"},{"type":"function","title":"JSON.LD.Utils.absolute_iri/2","doc":"Resolves a relative IRI against a base IRI.\n\nas specified in [section 5.1 Establishing a Base URI of RFC3986](http://tools.ietf.org/html/rfc3986#section-5.1).\nOnly the basic algorithm in [section 5.2 of RFC3986](http://tools.ietf.org/html/rfc3986#section-5.2)\nis used; neither Syntax-Based Normalization nor Scheme-Based Normalization are performed.\n\nCharacters additionally allowed in IRI references are treated in the same way that unreserved\ncharacters are treated in URI references, per [section 6.5 of RFC3987](http://tools.ietf.org/html/rfc3987#section-6.5)","ref":"JSON.LD.Utils.html#absolute_iri/2"},{"type":"function","title":"JSON.LD.Utils.blank_node_id?/1","doc":"Checks if the given value is a blank node identifier.\n\nA blank node identifier is a string that can be used as an identifier for a\nblank node within the scope of a JSON-LD document.\n\nBlank node identifiers begin with `_:`\n\nsee","ref":"JSON.LD.Utils.html#blank_node_id?/1"},{"type":"function","title":"JSON.LD.Utils.compact_iri_parts/2","doc":"","ref":"JSON.LD.Utils.html#compact_iri_parts/2"},{"type":"function","title":"JSON.LD.Utils.index?/1","doc":"","ref":"JSON.LD.Utils.html#index?/1"},{"type":"function","title":"JSON.LD.Utils.list?/1","doc":"","ref":"JSON.LD.Utils.html#list?/1"},{"type":"function","title":"JSON.LD.Utils.relative_iri?/1","doc":"","ref":"JSON.LD.Utils.html#relative_iri?/1"},{"type":"function","title":"JSON.LD.Utils.scalar?/1","doc":"","ref":"JSON.LD.Utils.html#scalar?/1"},{"type":"function","title":"JSON.LD.Utils.value?/1","doc":"","ref":"JSON.LD.Utils.html#value?/1"},{"type":"exception","title":"JSON.LD.CollidingKeywordsError","doc":"Two properties which expand to the same keyword have been detected. This might occur if a keyword and an alias thereof are used at the same time.","ref":"JSON.LD.CollidingKeywordsError.html"},{"type":"exception","title":"JSON.LD.CompactionToListOfListsError","doc":"The compacted document contains a list of lists as multiple lists have been compacted to the same term.","ref":"JSON.LD.CompactionToListOfListsError.html"},{"type":"exception","title":"JSON.LD.ConflictingIndexesError","doc":"Multiple conflicting indexes have been found for the same node.","ref":"JSON.LD.ConflictingIndexesError.html"},{"type":"exception","title":"JSON.LD.CyclicIRIMappingError","doc":"A cycle in IRI mappings has been detected.","ref":"JSON.LD.CyclicIRIMappingError.html"},{"type":"exception","title":"JSON.LD.InvalidBaseIRIError","doc":"An invalid base IRI has been detected, i.e., it is neither an absolute IRI nor null.","ref":"JSON.LD.InvalidBaseIRIError.html"},{"type":"exception","title":"JSON.LD.InvalidContainerMappingError","doc":"An @container member was encountered whose value was not one of the following strings: @list, @set, or @index.","ref":"JSON.LD.InvalidContainerMappingError.html"},{"type":"exception","title":"JSON.LD.InvalidDefaultLanguageError","doc":"The value of the default language is not a string or null and thus invalid.","ref":"JSON.LD.InvalidDefaultLanguageError.html"},{"type":"exception","title":"JSON.LD.InvalidIRIMappingError","doc":"A local context contains a term that has an invalid or missing IRI mapping..","ref":"JSON.LD.InvalidIRIMappingError.html"},{"type":"exception","title":"JSON.LD.InvalidIdValueError","doc":"An @id member was encountered whose value was not a string.","ref":"JSON.LD.InvalidIdValueError.html"},{"type":"exception","title":"JSON.LD.InvalidIndexValueError","doc":"An @index member was encountered whose value was not a string.","ref":"JSON.LD.InvalidIndexValueError.html"},{"type":"exception","title":"JSON.LD.InvalidKeywordAliasError","doc":"An invalid keyword alias definition has been encountered.","ref":"JSON.LD.InvalidKeywordAliasError.html"},{"type":"exception","title":"JSON.LD.InvalidLanguageMapValueError","doc":"An invalid value in a language map has been detected. It has to be a string or an array of strings.","ref":"JSON.LD.InvalidLanguageMapValueError.html"},{"type":"exception","title":"JSON.LD.InvalidLanguageMappingError","doc":"An @language member in a term definition was encountered whose value was neither a string nor null and thus invalid.","ref":"JSON.LD.InvalidLanguageMappingError.html"},{"type":"exception","title":"JSON.LD.InvalidLanguageTaggedStringError","doc":"A language-tagged string with an invalid language value was detected.","ref":"JSON.LD.InvalidLanguageTaggedStringError.html"},{"type":"exception","title":"JSON.LD.InvalidLanguageTaggedValueError","doc":"A number, true, or false with an associated language tag was detected.","ref":"JSON.LD.InvalidLanguageTaggedValueError.html"},{"type":"exception","title":"JSON.LD.InvalidLocalContextError","doc":"An invalid local context was detected.","ref":"JSON.LD.InvalidLocalContextError.html"},{"type":"exception","title":"JSON.LD.InvalidRemoteContextError","doc":"No valid context document has been found for a referenced, remote context.","ref":"JSON.LD.InvalidRemoteContextError.html"},{"type":"exception","title":"JSON.LD.InvalidReversePropertyError","doc":"An invalid reverse property definition has been detected.","ref":"JSON.LD.InvalidReversePropertyError.html"},{"type":"exception","title":"JSON.LD.InvalidReversePropertyMapError","doc":"CollidingKeywordsError","ref":"JSON.LD.InvalidReversePropertyMapError.html"},{"type":"exception","title":"JSON.LD.InvalidReversePropertyValueError","doc":"An invalid value for a reverse property has been detected. The value of an inverse property must be a node object.","ref":"JSON.LD.InvalidReversePropertyValueError.html"},{"type":"exception","title":"JSON.LD.InvalidReverseValueError","doc":"An invalid value for an @reverse member has been detected, i.e., the value was not a JSON object.","ref":"JSON.LD.InvalidReverseValueError.html"},{"type":"exception","title":"JSON.LD.InvalidSetOrListObjectError","doc":"A set object or list object with disallowed members has been detected.","ref":"JSON.LD.InvalidSetOrListObjectError.html"},{"type":"exception","title":"JSON.LD.InvalidTermDefinitionError","doc":"An invalid term definition has been detected.","ref":"JSON.LD.InvalidTermDefinitionError.html"},{"type":"exception","title":"JSON.LD.InvalidTypeMappingError","doc":"An @type member in a term definition was encountered whose value could not be expanded to an absolute IRI.","ref":"JSON.LD.InvalidTypeMappingError.html"},{"type":"exception","title":"JSON.LD.InvalidTypeValueError","doc":"An invalid value for an @type member has been detected, i.e., the value was neither a string nor an array of strings.","ref":"JSON.LD.InvalidTypeValueError.html"},{"type":"exception","title":"JSON.LD.InvalidTypedValueError","doc":"A typed value with an invalid type was detected.","ref":"JSON.LD.InvalidTypedValueError.html"},{"type":"exception","title":"JSON.LD.InvalidValueObjectError","doc":"A value object with disallowed members has been detected.","ref":"JSON.LD.InvalidValueObjectError.html"},{"type":"exception","title":"JSON.LD.InvalidValueObjectValueError","doc":"An invalid value for the @value member of a value object has been detected, i.e., it is neither a scalar nor null.","ref":"JSON.LD.InvalidValueObjectValueError.html"},{"type":"exception","title":"JSON.LD.InvalidVocabMappingError","doc":"An invalid vocabulary mapping has been detected, i.e., it is neither an absolute IRI nor null.","ref":"JSON.LD.InvalidVocabMappingError.html"},{"type":"exception","title":"JSON.LD.KeywordRedefinitionError","doc":"A keyword redefinition has been detected.","ref":"JSON.LD.KeywordRedefinitionError.html"},{"type":"exception","title":"JSON.LD.ListOfListsError","doc":"A list of lists was detected. List of lists are not supported in this version of JSON-LD due to the algorithmic complexity.","ref":"JSON.LD.ListOfListsError.html"},{"type":"exception","title":"JSON.LD.LoadingDocumentFailedError","doc":"The document could not be loaded or parsed as JSON.","ref":"JSON.LD.LoadingDocumentFailedError.html"},{"type":"exception","title":"JSON.LD.LoadingRemoteContextFailedError","doc":"There was a problem encountered loading a remote context.","ref":"JSON.LD.LoadingRemoteContextFailedError.html"},{"type":"exception","title":"JSON.LD.MultipleContextLinkHeadersError","doc":"Multiple HTTP Link Headers [RFC5988] using the http://www.w3.org/ns/json-ld#context link relation have been detected.","ref":"JSON.LD.MultipleContextLinkHeadersError.html"},{"type":"exception","title":"JSON.LD.RecursiveContextInclusionError","doc":"A cycle in remote context inclusions has been detected.","ref":"JSON.LD.RecursiveContextInclusionError.html"},{"type":"extras","title":"README","doc":"# JSON-LD.ex\n\n[![Hex.pm](https://img.shields.io/hexpm/v/json_ld.svg?style=flat-square)](https://hex.pm/packages/json_ld)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/json_ld/)\n[![Coverage Status](https://coveralls.io/repos/github/rdf-elixir/jsonld-ex/badge.svg?branch=master)](https://coveralls.io/github/rdf-elixir/jsonld-ex?branch=master)\n[![Total Download](https://img.shields.io/hexpm/dt/json_ld.svg)](https://hex.pm/packages/json_ld)\n[![License](https://img.shields.io/hexpm/l/json_ld.svg)](https://github.com/rdf-elixir/jsonld-ex/blob/master/LICENSE.md)\n\n[![ExUnit Tests](https://github.com/rdf-elixir/jsonld-ex/actions/workflows/elixir-build-and-test.yml/badge.svg)](https://github.com/rdf-elixir/jsonld-ex/actions/workflows/elixir-build-and-test.yml)\n[![Dialyzer](https://github.com/rdf-elixir/jsonld-ex/actions/workflows/elixir-dialyzer.yml/badge.svg)](https://github.com/rdf-elixir/jsonld-ex/actions/workflows/elixir-dialyzer.yml)\n[![Quality Checks](https://github.com/rdf-elixir/jsonld-ex/actions/workflows/elixir-quality-checks.yml/badge.svg)](https://github.com/rdf-elixir/jsonld-ex/actions/workflows/elixir-quality-checks.yml)\n\n\nAn implementation of the [JSON-LD] standard for Elixir and [RDF.ex].\n\nThe API documentation can be found [here](https://hexdocs.pm/json_ld/). For a guide and more information about RDF.ex and it's related projects, go to  .","ref":"readme.html"},{"type":"extras","title":"Features - README","doc":"- fully conforming JSON-LD 1.0 API processor\n- JSON-LD reader/writer for [RDF.ex]\n- tests of the [JSON-LD test suite][] (see [here](https://github.com/rdf-elixir/jsonld-ex/wiki/JSON-LD.ex-implementation-report) for a detailed status report)","ref":"readme.html#features"},{"type":"extras","title":"TODO - README","doc":"- [JSON-LD Framing]\n- [JSON-LD 1.1] support","ref":"readme.html#todo"},{"type":"extras","title":"Installation - README","doc":"The [JSON-LD.ex](https://hex.pm/packages/json_ld) Hex package can be installed as usual, by adding `json_ld` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:json_ld, \"~> 0.3\"}]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - README","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Expand a document - README","doc":"```elixir\n\"\"\"\n{\n \"@context\":\n {\n    \"name\": \"http://xmlns.com/foaf/0.1/name\",\n    \"homepage\": {\n      \"@id\": \"http://xmlns.com/foaf/0.1/homepage\",\n      \"@type\": \"@id\"\n    }\n },\n \"name\": \"Manu Sporny\",\n \"homepage\": \"http://manu.sporny.org/\"\n}\n\"\"\"\n|> Jason.decode!\n|> JSON.LD.expand\n```\n\nproduces\n\n```elixir\n[%{\"http://xmlns.com/foaf/0.1/homepage\" => [%{\"@id\" => \"http://manu.sporny.org/\"}],\n   \"http://xmlns.com/foaf/0.1/name\" => [%{\"@value\" => \"Manu Sporny\"}]}]\n```","ref":"readme.html#expand-a-document"},{"type":"extras","title":"Compact a document - README","doc":"```elixir\ncontext = Jason.decode! \"\"\"\n  {\n    \"@context\": {\n      \"name\": \"http://xmlns.com/foaf/0.1/name\",\n      \"homepage\": {\n        \"@id\": \"http://xmlns.com/foaf/0.1/homepage\",\n        \"@type\": \"@id\"\n      }\n    }\n  }\n  \"\"\"\n\n\"\"\"\n[\n  {\n    \"http://xmlns.com/foaf/0.1/name\": [ \"Manu Sporny\" ],\n    \"http://xmlns.com/foaf/0.1/homepage\": [\n      {\n       \"@id\": \"http://manu.sporny.org/\"\n      }\n    ]\n  }\n]\n\"\"\"\n|> Jason.decode!\n|> JSON.LD.compact(context)\n```\n\nproduces \n\n```elixir\n%{\"@context\" => %{\n    \"homepage\" => %{\n        \"@id\" => \"http://xmlns.com/foaf/0.1/homepage\", \n        \"@type\" => \"@id\"},\n    \"name\" => \"http://xmlns.com/foaf/0.1/name\"\n    },\n  \"homepage\" => \"http://manu.sporny.org/\", \n  \"name\" => \"Manu Sporny\"}\n```","ref":"readme.html#compact-a-document"},{"type":"extras","title":"RDF Reader and Writer - README","doc":"JSON-LD.ex can be used to serialize or deserialize RDF graphs by using it as a RDF.ex reader and writer.\n\n```elixir\ndataset = JSON.LD.read_file!(\"file.jsonld\")\nJSON.LD.write_file!(dataset, \"file.jsonld\")\n```\n\nWhen a context is provided via the `:context` option (as a map, a `RDF.PropertyMap` or a string with a URL to a remote context), the document gets automatically compacted on serialization.\n\n```elixir\nJSON.LD.write_file!(dataset, \"file.jsonld\", context: %{ex: \"https://example.com/\"})\nJSON.LD.write_file!(dataset, \"file.jsonld\", context: \"https://schema.org/\")\n```","ref":"readme.html#rdf-reader-and-writer"},{"type":"extras","title":"Pretty printing - README","doc":"Pretty printing is possible on all writer functions with all the formatter options of [Jason](https://hexdocs.pm/jason/Jason.Formatter.html#pretty_print/2), the underlying JSON encoder, to which the given options are passed through.\n\n```elixir\nJSON.LD.write_file!(dataset, \"file.jsonld\", pretty: true)\nJSON.LD.write_string(dataset, \"file.jsonld\", pretty: [indent: \"\\t\"])\n```","ref":"readme.html#pretty-printing"},{"type":"extras","title":"Contributing - README","doc":"see [CONTRIBUTING](CONTRIBUTING.md) for details.","ref":"readme.html#contributing"},{"type":"extras","title":"Consulting - README","doc":"If you need help with your Elixir and Linked Data projects, just contact [NinjaConcept](https://www.ninjaconcept.com/) via  .","ref":"readme.html#consulting"},{"type":"extras","title":"License and Copyright - README","doc":"(c) 2017-present Marcel Otto. MIT Licensed, see [LICENSE](LICENSE.md) for details.\n\n\n[RDF.ex]:             https://hex.pm/packages/rdf\n[JSON-LD]:            http://www.w3.org/TR/json-ld/ \"JSON-LD 1.0\"\n[JSON-LD 1.1]:        https://json-ld.org/spec/latest/json-ld/ \"JSON-LD 1.1\"\n[JSON-LD API]:        http://www.w3.org/TR/json-ld-api/ \"JSON-LD 1.0 Processing Algorithms and API\"\n[JSON-LD Framing]:    http://json-ld.org/spec/latest/json-ld-framing/\n[JSON-LD test suite]: http://json-ld.org/test-suite/","ref":"readme.html#license-and-copyright"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nThis project adheres to [Semantic Versioning](http://semver.org/) and\n[Keep a CHANGELOG](http://keepachangelog.com).","ref":"changelog.html"},{"type":"extras","title":"0.3.9 - 2024-08-07 - Change Log","doc":"This version is just upgraded to RDF.ex 2.0.\n\nElixir versions < 1.13 and OTP version < 23 are no longer supported\n\n[Compare v0.3.8...v0.3.9](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.8...v0.3.9)","ref":"changelog.html#0-3-9-2024-08-07"},{"type":"extras","title":"0.3.8 - 2023-12-18 - Change Log","doc":"","ref":"changelog.html#0-3-8-2023-12-18"},{"type":"extras","title":"Added - Change Log","doc":"- Support for httpoison 2.0 ([@maennchen](https://github.com/maennchen))\n\n[Compare v0.3.7...v0.3.8](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.7...v0.3.8)","ref":"changelog.html#added"},{"type":"extras","title":"0.3.7 - 2023-01-23 - Change Log","doc":"","ref":"changelog.html#0-3-7-2023-01-23"},{"type":"extras","title":"Added - Change Log","doc":"- Support Link header when fetching remote contexts ([@cheerfulstoic](https://github.com/cheerfulstoic))\n\n[Compare v0.3.6...v0.3.7](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.6...v0.3.7)","ref":"changelog.html#added"},{"type":"extras","title":"0.3.6 - 2022-11-03 - Change Log","doc":"This version is just upgraded to RDF.ex 1.0.\n\nElixir versions < 1.11 are no longer supported\n\n[Compare v0.3.5...v0.3.6](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.5...v0.3.6)","ref":"changelog.html#0-3-6-2022-11-03"},{"type":"extras","title":"0.3.5 - 2022-04-26 - Change Log","doc":"","ref":"changelog.html#0-3-5-2022-04-26"},{"type":"extras","title":"Added - Change Log","doc":"- the `JSON.LD.Encoder` now supports implicit compaction by providing a context\n  as a map, a `RDF.PropertyMap` or a URL string for a remote context with the \n  new `:context` option","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Change Log","doc":"- context maps can be given now with atom keys or as a `RDF.PropertyMap` to\n  `JSON.LD.context/2` and `JSON.LD.compact/3`\n- the base IRI of a `RDF.Graph` or the `RDF.default_base_iri/0` is used as the  \n  default `:base` in the `JSON.LD.Encoder`\n- `RDF.Vocabulary.Namespace` modules can be set as base IRI \n\n\n[Compare v0.3.4...v0.3.5](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.4...v0.3.5)","ref":"changelog.html#changed"},{"type":"extras","title":"0.3.4 - 2021-12-13 - Change Log","doc":"Elixir versions < 1.10 are no longer supported","ref":"changelog.html#0-3-4-2021-12-13"},{"type":"extras","title":"Fixed - Change Log","doc":"- remote contexts with a list couldn't be processed correctly (but failed with a `JSON.LD.InvalidLocalContextError`)\n\n[Compare v0.3.3...v0.3.4](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.3...v0.3.4)","ref":"changelog.html#fixed"},{"type":"extras","title":"0.3.3 - 2020-10-13 - Change Log","doc":"This version mainly upgrades to RDF.ex 0.9.","ref":"changelog.html#0-3-3-2020-10-13"},{"type":"extras","title":"Added - Change Log","doc":"- proper typespecs so that Dialyzer passes without warnings ([@rustra](https://github.com/rustra))\n\n[Compare v0.3.2...v0.3.3](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.2...v0.3.3)","ref":"changelog.html#added"},{"type":"extras","title":"0.3.2 - 2020-06-19 - Change Log","doc":"","ref":"changelog.html#0-3-2-2020-06-19"},{"type":"extras","title":"Added - Change Log","doc":"Support for remote contexts ([@KokaKiwi](https://github.com/KokaKiwi) and [@rustra](https://github.com/rustra))\n\n[Compare v0.3.1...v0.3.2](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.1...v0.3.2)","ref":"changelog.html#added"},{"type":"extras","title":"0.3.1 - 2020-06-01 - Change Log","doc":"This version just upgrades to RDF.ex 0.8. With that Elixir version < 1.8 are no longer supported.\n\n[Compare v0.3.0...v0.3.1](https://github.com/rdf-elixir/jsonld-ex/compare/v0.3.0...v0.3.1)","ref":"changelog.html#0-3-1-2020-06-01"},{"type":"extras","title":"0.3.0 - 2018-09-17 - Change Log","doc":"No significant changes. Just some adoptions to work with RDF.ex 0.5. \nBut together with RDF.ex 0.5, Elixir versions < 1.6 are no longer supported.\n\n[Compare v0.2.3...v0.3.0](https://github.com/rdf-elixir/jsonld-ex/compare/v0.2.3...v0.3.0)","ref":"changelog.html#0-3-0-2018-09-17"},{"type":"extras","title":"0.2.3 - 2018-07-11 - Change Log","doc":"- Upgrade to Jason 1.1\n- Pass options to `JSON.LD.Encoder.encode/2` and `JSON.LD.Encoder.encode!/2` \n  through to Jason; this allows to use the new Jason pretty printing options  \n\n[Compare v0.2.2...v0.2.3](https://github.com/rdf-elixir/jsonld-ex/compare/v0.2.2...v0.2.3)","ref":"changelog.html#0-2-3-2018-07-11"},{"type":"extras","title":"0.2.2 - 2018-03-17 - Change Log","doc":"","ref":"changelog.html#0-2-2-2018-03-17"},{"type":"extras","title":"Added - Change Log","doc":"- JSON-LD encoder can handle `RDF.Graph`s and `RDF.Description`s","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Change Log","doc":"- Use Jason instead of Poison for JSON encoding and decoding, since it's faster and more standard conform\n\n\n[Compare v0.2.1...v0.2.2](https://github.com/rdf-elixir/jsonld-ex/compare/v0.2.1...v0.2.2)","ref":"changelog.html#changed"},{"type":"extras","title":"0.2.1 - 2018-03-10 - Change Log","doc":"","ref":"changelog.html#0-2-1-2018-03-10"},{"type":"extras","title":"Changed - Change Log","doc":"- Upgrade to RDF.ex 0.4.0\n- Fixed all warnings ([@talklittle](https://github.com/talklittle)) \n\n\n[Compare v0.2.0...v0.2.1](https://github.com/rdf-elixir/jsonld-ex/compare/v0.2.0...v0.2.1)","ref":"changelog.html#changed"},{"type":"extras","title":"0.2.0 - 2017-08-24 - Change Log","doc":"","ref":"changelog.html#0-2-0-2017-08-24"},{"type":"extras","title":"Changed - Change Log","doc":"- Upgrade to RDF.ex 0.3.0\n\n\n[Compare v0.1.1...v0.2.0](https://github.com/rdf-elixir/jsonld-ex/compare/v0.1.1...v0.2.0)","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.1 - 2017-08-06 - Change Log","doc":"","ref":"changelog.html#0-1-1-2017-08-06"},{"type":"extras","title":"Changed - Change Log","doc":"- Don't support Elixir versions < 1.5, since `URI.merge` is broken in earlier versions  \n\n\n[Compare v0.1.0...v0.1.1](https://github.com/rdf-elixir/jsonld-ex/compare/v0.1.0...v0.1.1)","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.0 - 2017-06-25 - Change Log","doc":"Initial release","ref":"changelog.html#0-1-0-2017-06-25"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}